i18n: make GETTEXT_POISON a runtime option
[git/git.git] / t / test-lib-functions.sh
CommitLineData
c74c7203
JN
1# Library of functions shared by all tests scripts, included by
2# test-lib.sh.
12a29b1a
TR
3#
4# Copyright (c) 2005 Junio C Hamano
5#
6# This program is free software: you can redistribute it and/or modify
7# it under the terms of the GNU General Public License as published by
8# the Free Software Foundation, either version 2 of the License, or
9# (at your option) any later version.
10#
11# This program is distributed in the hope that it will be useful,
12# but WITHOUT ANY WARRANTY; without even the implied warranty of
13# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
14# GNU General Public License for more details.
15#
16# You should have received a copy of the GNU General Public License
17# along with this program. If not, see http://www.gnu.org/licenses/ .
18
19# The semantics of the editor variables are that of invoking
20# sh -c "$EDITOR \"$@\"" files ...
21#
22# If our trash directory contains shell metacharacters, they will be
23# interpreted if we just set $EDITOR directly, so do a little dance with
24# environment variables to work around this.
25#
26# In particular, quoting isn't enough, as the path may contain the same quote
27# that we're using.
28test_set_editor () {
29 FAKE_EDITOR="$1"
30 export FAKE_EDITOR
31 EDITOR='"$FAKE_EDITOR"'
32 export EDITOR
33}
34
5d9fc888
TG
35test_set_index_version () {
36 GIT_INDEX_VERSION="$1"
37 export GIT_INDEX_VERSION
38}
39
12a29b1a
TR
40test_decode_color () {
41 awk '
42 function name(n) {
43 if (n == 0) return "RESET";
44 if (n == 1) return "BOLD";
991eb4fc
SB
45 if (n == 2) return "FAINT";
46 if (n == 3) return "ITALIC";
097b681b 47 if (n == 7) return "REVERSE";
12a29b1a
TR
48 if (n == 30) return "BLACK";
49 if (n == 31) return "RED";
50 if (n == 32) return "GREEN";
51 if (n == 33) return "YELLOW";
52 if (n == 34) return "BLUE";
53 if (n == 35) return "MAGENTA";
54 if (n == 36) return "CYAN";
55 if (n == 37) return "WHITE";
56 if (n == 40) return "BLACK";
57 if (n == 41) return "BRED";
58 if (n == 42) return "BGREEN";
59 if (n == 43) return "BYELLOW";
60 if (n == 44) return "BBLUE";
61 if (n == 45) return "BMAGENTA";
62 if (n == 46) return "BCYAN";
63 if (n == 47) return "BWHITE";
64 }
65 {
66 while (match($0, /\033\[[0-9;]*m/) != 0) {
67 printf "%s<", substr($0, 1, RSTART-1);
68 codes = substr($0, RSTART+2, RLENGTH-3);
69 if (length(codes) == 0)
70 printf "%s", name(0)
71 else {
72 n = split(codes, ary, ";");
73 sep = "";
74 for (i = 1; i <= n; i++) {
75 printf "%s%s", sep, name(ary[i]);
76 sep = ";"
77 }
78 }
79 printf ">";
80 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
81 }
82 print
83 }
84 '
85}
86
b249e39f
JH
87lf_to_nul () {
88 perl -pe 'y/\012/\000/'
89}
90
12a29b1a 91nul_to_q () {
94221d22 92 perl -pe 'y/\000/Q/'
12a29b1a
TR
93}
94
95q_to_nul () {
94221d22 96 perl -pe 'y/Q/\000/'
12a29b1a
TR
97}
98
99q_to_cr () {
100 tr Q '\015'
101}
102
103q_to_tab () {
104 tr Q '\011'
105}
106
250b3c6c
JH
107qz_to_tab_space () {
108 tr QZ '\011\040'
12a29b1a
TR
109}
110
111append_cr () {
112 sed -e 's/$/Q/' | tr Q '\015'
113}
114
115remove_cr () {
116 tr '\015' Q | sed -e 's/Q$//'
117}
118
119# In some bourne shell implementations, the "unset" builtin returns
120# nonzero status when a variable to be unset was not set in the first
121# place.
122#
123# Use sane_unset when that should not be considered an error.
124
125sane_unset () {
126 unset "$@"
127 return 0
128}
129
130test_tick () {
131 if test -z "${test_tick+set}"
132 then
133 test_tick=1112911993
134 else
135 test_tick=$(($test_tick + 60))
136 fi
137 GIT_COMMITTER_DATE="$test_tick -0700"
138 GIT_AUTHOR_DATE="$test_tick -0700"
139 export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
140}
141
59210dd5 142# Stop execution and start a shell. This is useful for debugging tests.
12a29b1a
TR
143#
144# Be sure to remove all invocations of this command before submitting.
145
146test_pause () {
59210dd5 147 "$SHELL_PATH" <&6 >&5 2>&7
12a29b1a
TR
148}
149
84243646
EN
150# Wrap git with a debugger. Adding this to a command can make it easier
151# to understand what is going on in a failing test.
6a94088c 152#
84243646
EN
153# Examples:
154# debug git checkout master
155# debug --debugger=nemiver git $ARGS
156# debug -d "valgrind --tool=memcheck --track-origins=yes" git $ARGS
6a94088c 157debug () {
84243646
EN
158 case "$1" in
159 -d)
160 GIT_DEBUGGER="$2" &&
161 shift 2
162 ;;
163 --debugger=*)
164 GIT_DEBUGGER="${1#*=}" &&
165 shift 1
166 ;;
167 *)
168 GIT_DEBUGGER=1
169 ;;
170 esac &&
171 GIT_DEBUGGER="${GIT_DEBUGGER}" "$@" <&6 >&5 2>&7
6a94088c
JS
172}
173
6f94351b
SB
174# Call test_commit with the arguments
175# [-C <directory>] <message> [<file> [<contents> [<tag>]]]"
12a29b1a
TR
176#
177# This will commit a file with the given contents and the given commit
4c994194 178# message, and tag the resulting commit with the given tag name.
12a29b1a 179#
4c994194 180# <file>, <contents>, and <tag> all default to <message>.
6f94351b
SB
181#
182# If the first argument is "-C", the second argument is used as a path for
183# the git invocations.
12a29b1a
TR
184
185test_commit () {
9a0231b3 186 notick= &&
5ed75e2a 187 signoff= &&
6f94351b 188 indir= &&
5ed75e2a
MV
189 while test $# != 0
190 do
191 case "$1" in
192 --notick)
193 notick=yes
194 ;;
195 --signoff)
196 signoff="$1"
197 ;;
6f94351b
SB
198 -C)
199 indir="$2"
200 shift
201 ;;
5ed75e2a
MV
202 *)
203 break
204 ;;
205 esac
9a0231b3 206 shift
5ed75e2a 207 done &&
6f94351b 208 indir=${indir:+"$indir"/} &&
9a0231b3 209 file=${2:-"$1.t"} &&
6f94351b
SB
210 echo "${3-$1}" > "$indir$file" &&
211 git ${indir:+ -C "$indir"} add "$file" &&
9a0231b3
JH
212 if test -z "$notick"
213 then
214 test_tick
215 fi &&
6f94351b
SB
216 git ${indir:+ -C "$indir"} commit $signoff -m "$1" &&
217 git ${indir:+ -C "$indir"} tag "${4:-$1}"
12a29b1a
TR
218}
219
220# Call test_merge with the arguments "<message> <commit>", where <commit>
221# can be a tag pointing to the commit-to-merge.
222
223test_merge () {
224 test_tick &&
225 git merge -m "$1" "$2" &&
226 git tag "$1"
227}
228
229# This function helps systems where core.filemode=false is set.
230# Use it instead of plain 'chmod +x' to set or unset the executable bit
231# of a file in the working directory and add it to the index.
232
233test_chmod () {
234 chmod "$@" &&
235 git update-index --add "--chmod=$@"
236}
237
73de1c93
CC
238# Get the modebits from a file.
239test_modebits () {
240 ls -l "$1" | sed -e 's|^\(..........\).*|\1|'
241}
242
12a29b1a
TR
243# Unset a configuration variable, but don't fail if it doesn't exist.
244test_unconfig () {
5fafc07f
JK
245 config_dir=
246 if test "$1" = -C
247 then
248 shift
249 config_dir=$1
250 shift
251 fi
252 git ${config_dir:+-C "$config_dir"} config --unset-all "$@"
12a29b1a
TR
253 config_status=$?
254 case "$config_status" in
255 5) # ok, nothing to unset
256 config_status=0
257 ;;
258 esac
259 return $config_status
260}
261
262# Set git config, automatically unsetting it after the test is over.
263test_config () {
5fafc07f
JK
264 config_dir=
265 if test "$1" = -C
266 then
267 shift
268 config_dir=$1
269 shift
270 fi
271 test_when_finished "test_unconfig ${config_dir:+-C '$config_dir'} '$1'" &&
272 git ${config_dir:+-C "$config_dir"} config "$@"
12a29b1a
TR
273}
274
275test_config_global () {
276 test_when_finished "test_unconfig --global '$1'" &&
277 git config --global "$@"
278}
279
280write_script () {
281 {
282 echo "#!${2-"$SHELL_PATH"}" &&
283 cat
284 } >"$1" &&
285 chmod +x "$1"
286}
287
288# Use test_set_prereq to tell that a particular prerequisite is available.
289# The prerequisite can later be checked for in two ways:
290#
291# - Explicitly using test_have_prereq.
292#
293# - Implicitly by specifying the prerequisite tag in the calls to
294# test_expect_{success,failure,code}.
295#
296# The single parameter is the prerequisite tag (a simple word, in all
297# capital letters by convention).
298
7d0ee47c
JS
299test_unset_prereq () {
300 ! test_have_prereq "$1" ||
301 satisfied_prereq="${satisfied_prereq% $1 *} ${satisfied_prereq#* $1 }"
302}
303
12a29b1a 304test_set_prereq () {
7d0ee47c
JS
305 case "$1" in
306 !*)
307 test_unset_prereq "${1#!}"
308 ;;
309 *)
310 satisfied_prereq="$satisfied_prereq$1 "
311 ;;
312 esac
12a29b1a 313}
f3cfc3b2 314satisfied_prereq=" "
04083f27
JH
315lazily_testable_prereq= lazily_tested_prereq=
316
317# Usage: test_lazy_prereq PREREQ 'script'
318test_lazy_prereq () {
319 lazily_testable_prereq="$lazily_testable_prereq$1 "
320 eval test_prereq_lazily_$1=\$2
321}
322
323test_run_lazy_prereq_ () {
324 script='
325mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
326(
327 cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
328)'
329 say >&3 "checking prerequisite: $1"
330 say >&3 "$script"
331 test_eval_ "$script"
332 eval_ret=$?
333 rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
334 if test "$eval_ret" = 0; then
335 say >&3 "prerequisite $1 ok"
336 else
337 say >&3 "prerequisite $1 not satisfied"
338 fi
339 return $eval_ret
340}
12a29b1a
TR
341
342test_have_prereq () {
343 # prerequisites can be concatenated with ','
344 save_IFS=$IFS
345 IFS=,
346 set -- $*
347 IFS=$save_IFS
348
349 total_prereq=0
350 ok_prereq=0
351 missing_prereq=
352
353 for prerequisite
354 do
bdccd3c1
JK
355 case "$prerequisite" in
356 !*)
357 negative_prereq=t
358 prerequisite=${prerequisite#!}
359 ;;
360 *)
361 negative_prereq=
362 esac
363
04083f27
JH
364 case " $lazily_tested_prereq " in
365 *" $prerequisite "*)
366 ;;
367 *)
368 case " $lazily_testable_prereq " in
369 *" $prerequisite "*)
370 eval "script=\$test_prereq_lazily_$prerequisite" &&
371 if test_run_lazy_prereq_ "$prerequisite" "$script"
372 then
373 test_set_prereq $prerequisite
374 fi
375 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
376 esac
377 ;;
378 esac
379
12a29b1a 380 total_prereq=$(($total_prereq + 1))
f3cfc3b2 381 case "$satisfied_prereq" in
12a29b1a 382 *" $prerequisite "*)
bdccd3c1
JK
383 satisfied_this_prereq=t
384 ;;
385 *)
386 satisfied_this_prereq=
387 esac
388
389 case "$satisfied_this_prereq,$negative_prereq" in
390 t,|,t)
12a29b1a
TR
391 ok_prereq=$(($ok_prereq + 1))
392 ;;
393 *)
bdccd3c1
JK
394 # Keep a list of missing prerequisites; restore
395 # the negative marker if necessary.
396 prerequisite=${negative_prereq:+!}$prerequisite
12a29b1a
TR
397 if test -z "$missing_prereq"
398 then
399 missing_prereq=$prerequisite
400 else
401 missing_prereq="$prerequisite,$missing_prereq"
402 fi
403 esac
404 done
405
406 test $total_prereq = $ok_prereq
407}
408
409test_declared_prereq () {
410 case ",$test_prereq," in
411 *,$1,*)
412 return 0
413 ;;
414 esac
415 return 1
416}
417
d93d5d51
JH
418test_verify_prereq () {
419 test -z "$test_prereq" ||
420 expr >/dev/null "$test_prereq" : '[A-Z0-9_,!]*$' ||
421 error "bug in the test script: '$test_prereq' does not look like a prereq"
422}
423
12a29b1a 424test_expect_failure () {
ae75342c 425 test_start_
12a29b1a
TR
426 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
427 test "$#" = 2 ||
428 error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
d93d5d51 429 test_verify_prereq
12a29b1a
TR
430 export test_prereq
431 if ! test_skip "$@"
432 then
433 say >&3 "checking known breakage: $2"
434 if test_run_ "$2" expecting_failure
435 then
436 test_known_broken_ok_ "$1"
437 else
438 test_known_broken_failure_ "$1"
439 fi
440 fi
ae75342c 441 test_finish_
12a29b1a
TR
442}
443
444test_expect_success () {
ae75342c 445 test_start_
12a29b1a
TR
446 test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
447 test "$#" = 2 ||
448 error "bug in the test script: not 2 or 3 parameters to test-expect-success"
d93d5d51 449 test_verify_prereq
12a29b1a
TR
450 export test_prereq
451 if ! test_skip "$@"
452 then
453 say >&3 "expecting success: $2"
454 if test_run_ "$2"
455 then
456 test_ok_ "$1"
457 else
458 test_failure_ "$@"
459 fi
460 fi
ae75342c 461 test_finish_
12a29b1a
TR
462}
463
464# test_external runs external test scripts that provide continuous
465# test output about their progress, and succeeds/fails on
466# zero/non-zero exit code. It outputs the test output on stdout even
467# in non-verbose mode, and announces the external script with "# run
468# <n>: ..." before running it. When providing relative paths, keep in
469# mind that all scripts run in "trash directory".
470# Usage: test_external description command arguments...
471# Example: test_external 'Perl API' perl ../path/to/test.pl
472test_external () {
473 test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
474 test "$#" = 3 ||
475 error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
476 descr="$1"
477 shift
d93d5d51 478 test_verify_prereq
12a29b1a
TR
479 export test_prereq
480 if ! test_skip "$descr" "$@"
481 then
482 # Announce the script to reduce confusion about the
483 # test output that follows.
484 say_color "" "# run $test_count: $descr ($*)"
485 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
486 # to be able to use them in script
487 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
488 # Run command; redirect its stderr to &4 as in
489 # test_run_, but keep its stdout on our stdout even in
490 # non-verbose mode.
491 "$@" 2>&4
9e8f8dea 492 if test "$?" = 0
12a29b1a
TR
493 then
494 if test $test_external_has_tap -eq 0; then
495 test_ok_ "$descr"
496 else
497 say_color "" "# test_external test $descr was ok"
498 test_success=$(($test_success + 1))
499 fi
500 else
501 if test $test_external_has_tap -eq 0; then
502 test_failure_ "$descr" "$@"
503 else
504 say_color error "# test_external test $descr failed: $@"
505 test_failure=$(($test_failure + 1))
506 fi
507 fi
508 fi
509}
510
511# Like test_external, but in addition tests that the command generated
512# no output on stderr.
513test_external_without_stderr () {
514 # The temporary file has no (and must have no) security
515 # implications.
516 tmp=${TMPDIR:-/tmp}
517 stderr="$tmp/git-external-stderr.$$.tmp"
518 test_external "$@" 4> "$stderr"
9e8f8dea 519 test -f "$stderr" || error "Internal error: $stderr disappeared."
12a29b1a
TR
520 descr="no stderr: $1"
521 shift
522 say >&3 "# expecting no stderr from previous command"
9e8f8dea
DA
523 if test ! -s "$stderr"
524 then
12a29b1a
TR
525 rm "$stderr"
526
527 if test $test_external_has_tap -eq 0; then
528 test_ok_ "$descr"
529 else
530 say_color "" "# test_external_without_stderr test $descr was ok"
531 test_success=$(($test_success + 1))
532 fi
533 else
9e8f8dea
DA
534 if test "$verbose" = t
535 then
536 output=$(echo; echo "# Stderr is:"; cat "$stderr")
12a29b1a
TR
537 else
538 output=
539 fi
540 # rm first in case test_failure exits.
541 rm "$stderr"
542 if test $test_external_has_tap -eq 0; then
543 test_failure_ "$descr" "$@" "$output"
544 else
545 say_color error "# test_external_without_stderr test $descr failed: $@: $output"
546 test_failure=$(($test_failure + 1))
547 fi
548 fi
549}
550
551# debugging-friendly alternatives to "test [-f|-d|-e]"
552# The commands test the existence or non-existence of $1. $2 can be
553# given to provide a more precise diagnosis.
554test_path_is_file () {
9e8f8dea 555 if ! test -f "$1"
12a29b1a 556 then
de248e92 557 echo "File $1 doesn't exist. $2"
12a29b1a
TR
558 false
559 fi
560}
561
562test_path_is_dir () {
9e8f8dea 563 if ! test -d "$1"
12a29b1a 564 then
de248e92 565 echo "Directory $1 doesn't exist. $2"
12a29b1a
TR
566 false
567 fi
568}
569
7e9055bb
EN
570test_path_exists () {
571 if ! test -e "$1"
572 then
573 echo "Path $1 doesn't exist. $2"
574 false
575 fi
576}
577
0be7d9b7
JL
578# Check if the directory exists and is empty as expected, barf otherwise.
579test_dir_is_empty () {
580 test_path_is_dir "$1" &&
581 if test -n "$(ls -a1 "$1" | egrep -v '^\.\.?$')"
582 then
583 echo "Directory '$1' is not empty, it contains:"
584 ls -la "$1"
585 return 1
586 fi
587}
588
12a29b1a 589test_path_is_missing () {
9e8f8dea 590 if test -e "$1"
12a29b1a
TR
591 then
592 echo "Path exists:"
593 ls -ld "$1"
9e8f8dea
DA
594 if test $# -ge 1
595 then
12a29b1a
TR
596 echo "$*"
597 fi
598 false
599 fi
600}
601
602# test_line_count checks that a file has the number of lines it
603# ought to. For example:
604#
605# test_expect_success 'produce exactly one line of output' '
606# do something >output &&
607# test_line_count = 1 output
608# '
609#
610# is like "test $(wc -l <output) = 1" except that it passes the
611# output through when the number of lines is wrong.
612
613test_line_count () {
614 if test $# != 3
615 then
616 error "bug in the test script: not 3 parameters to test_line_count"
617 elif ! test $(wc -l <"$3") "$1" "$2"
618 then
619 echo "test_line_count: line count for $3 !$1 $2"
620 cat "$3"
621 return 1
622 fi
623}
624
bbfe5302
LS
625# Returns success if a comma separated string of keywords ($1) contains a
626# given keyword ($2).
627# Examples:
628# `list_contains "foo,bar" bar` returns 0
629# `list_contains "foo" bar` returns 1
630
631list_contains () {
632 case ",$1," in
633 *,$2,*)
634 return 0
635 ;;
636 esac
637 return 1
638}
639
12a29b1a
TR
640# This is not among top-level (test_expect_success | test_expect_failure)
641# but is a prefix that can be used in the test script, like:
642#
643# test_expect_success 'complain and die' '
644# do something &&
645# do something else &&
646# test_must_fail git checkout ../outerspace
647# '
648#
649# Writing this as "! git checkout ../outerspace" is wrong, because
650# the failure could be due to a segv. We want a controlled failure.
12e31a6b
SG
651#
652# Accepts the following options:
653#
654# ok=<signal-name>[,<...>]:
655# Don't treat an exit caused by the given signal as error.
656# Multiple signals can be specified as a comma separated list.
657# Currently recognized signal names are: sigpipe, success.
658# (Don't use 'success', use 'test_might_fail' instead.)
12a29b1a
TR
659
660test_must_fail () {
bbfe5302
LS
661 case "$1" in
662 ok=*)
663 _test_ok=${1#ok=}
664 shift
665 ;;
666 *)
667 _test_ok=
668 ;;
669 esac
a5bf824f 670 "$@" 2>&7
12a29b1a 671 exit_code=$?
bbfe5302
LS
672 if test $exit_code -eq 0 && ! list_contains "$_test_ok" success
673 then
03aa3783 674 echo >&4 "test_must_fail: command succeeded: $*"
12a29b1a 675 return 1
2472448c 676 elif test_match_signal 13 $exit_code && list_contains "$_test_ok" sigpipe
8bf4becf
LS
677 then
678 return 0
bbfe5302
LS
679 elif test $exit_code -gt 129 && test $exit_code -le 192
680 then
03aa3783 681 echo >&4 "test_must_fail: died by signal $(($exit_code - 128)): $*"
12a29b1a 682 return 1
bbfe5302
LS
683 elif test $exit_code -eq 127
684 then
03aa3783 685 echo >&4 "test_must_fail: command not found: $*"
12a29b1a 686 return 1
bbfe5302
LS
687 elif test $exit_code -eq 126
688 then
03aa3783 689 echo >&4 "test_must_fail: valgrind error: $*"
eeb69131 690 return 1
12a29b1a
TR
691 fi
692 return 0
a5bf824f 693} 7>&2 2>&4
12a29b1a
TR
694
695# Similar to test_must_fail, but tolerates success, too. This is
696# meant to be used in contexts like:
697#
698# test_expect_success 'some command works without configuration' '
699# test_might_fail git config --unset all.configuration &&
700# do something
701# '
702#
703# Writing "git config --unset all.configuration || :" would be wrong,
704# because we want to notice if it fails due to segv.
12e31a6b
SG
705#
706# Accepts the same options as test_must_fail.
12a29b1a
TR
707
708test_might_fail () {
a5bf824f
SG
709 test_must_fail ok=success "$@" 2>&7
710} 7>&2 2>&4
12a29b1a
TR
711
712# Similar to test_must_fail and test_might_fail, but check that a
713# given command exited with a given exit code. Meant to be used as:
714#
715# test_expect_success 'Merge with d/f conflicts' '
716# test_expect_code 1 git merge "merge msg" B master
717# '
718
719test_expect_code () {
720 want_code=$1
721 shift
a5bf824f 722 "$@" 2>&7
12a29b1a
TR
723 exit_code=$?
724 if test $exit_code = $want_code
725 then
726 return 0
727 fi
728
03aa3783 729 echo >&4 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
12a29b1a 730 return 1
a5bf824f 731} 7>&2 2>&4
12a29b1a
TR
732
733# test_cmp is a helper function to compare actual and expected output.
734# You can use it like:
735#
736# test_expect_success 'foo works' '
737# echo expected >expected &&
738# foo >actual &&
739# test_cmp expected actual
740# '
741#
742# This could be written as either "cmp" or "diff -u", but:
743# - cmp's output is not nearly as easy to read as diff -u
744# - not all diff versions understand "-u"
745
746test_cmp() {
747 $GIT_TEST_CMP "$@"
748}
749
b93e6e36
SK
750# test_cmp_bin - helper to compare binary files
751
752test_cmp_bin() {
753 cmp "$@"
754}
755
0f59128f
SG
756# Use this instead of test_cmp to compare files that contain expected and
757# actual output from git commands that can be translated. When running
6cdccfce 758# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
759# results.
760test_i18ncmp () {
6cdccfce 761 ! test_have_prereq C_LOCALE_OUTPUT || test_cmp "$@"
0f59128f
SG
762}
763
764# Use this instead of "grep expected-string actual" to see if the
765# output from a git command that can be translated either contains an
766# expected string, or does not contain an unwanted one. When running
6cdccfce 767# under GIT_TEST_GETTEXT_POISON this pretends that the command produced expected
0f59128f
SG
768# results.
769test_i18ngrep () {
fd29d7b9
SG
770 eval "last_arg=\${$#}"
771
772 test -f "$last_arg" ||
773 error "bug in the test script: test_i18ngrep requires a file" \
774 "to read as the last parameter"
775
776 if test $# -lt 2 ||
777 { test "x!" = "x$1" && test $# -lt 3 ; }
778 then
779 error "bug in the test script: too few parameters to test_i18ngrep"
780 fi
781
6cdccfce 782 if test_have_prereq !C_LOCALE_OUTPUT
0f59128f 783 then
63b1a175
SG
784 # pretend success
785 return 0
786 fi
787
788 if test "x!" = "x$1"
0f59128f
SG
789 then
790 shift
63b1a175
SG
791 ! grep "$@" && return 0
792
03aa3783 793 echo >&4 "error: '! grep $@' did find a match in:"
0f59128f 794 else
63b1a175
SG
795 grep "$@" && return 0
796
03aa3783 797 echo >&4 "error: 'grep $@' didn't find a match in:"
0f59128f 798 fi
63b1a175
SG
799
800 if test -s "$last_arg"
801 then
03aa3783 802 cat >&4 "$last_arg"
63b1a175 803 else
03aa3783 804 echo >&4 "<File '$last_arg' is empty>"
63b1a175
SG
805 fi
806
807 return 1
0f59128f
SG
808}
809
8ad16524
JK
810# Call any command "$@" but be more verbose about its
811# failure. This is handy for commands like "test" which do
812# not output anything when they fail.
813verbose () {
814 "$@" && return 0
03aa3783 815 echo >&4 "command failed: $(git rev-parse --sq-quote "$@")"
8ad16524
JK
816 return 1
817}
818
ca8d148d
JH
819# Check if the file expected to be empty is indeed empty, and barfs
820# otherwise.
821
822test_must_be_empty () {
9eb23080
SG
823 test_path_is_file "$1" &&
824 if test -s "$1"
ca8d148d
JH
825 then
826 echo "'$1' is not empty, it contains:"
827 cat "$1"
828 return 1
829 fi
830}
831
5d77298d
MZ
832# Tests that its two parameters refer to the same revision
833test_cmp_rev () {
834 git rev-parse --verify "$1" >expect.rev &&
835 git rev-parse --verify "$2" >actual.rev &&
836 test_cmp expect.rev actual.rev
837}
838
55672a39
JH
839# Print a sequence of integers in increasing order, either with
840# two arguments (start and end):
d17cf5f3 841#
55672a39
JH
842# test_seq 1 5 -- outputs 1 2 3 4 5 one line at a time
843#
844# or with one argument (end), in which case it starts counting
845# from 1.
d17cf5f3
MK
846
847test_seq () {
848 case $# in
849 1) set 1 "$@" ;;
850 2) ;;
851 *) error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
852 esac
4df43135
JH
853 test_seq_counter__=$1
854 while test "$test_seq_counter__" -le "$2"
855 do
856 echo "$test_seq_counter__"
857 test_seq_counter__=$(( $test_seq_counter__ + 1 ))
858 done
d17cf5f3
MK
859}
860
12a29b1a
TR
861# This function can be used to schedule some commands to be run
862# unconditionally at the end of the test to restore sanity:
863#
864# test_expect_success 'test core.capslock' '
865# git config core.capslock true &&
866# test_when_finished "git config --unset core.capslock" &&
867# hello world
868# '
869#
870# That would be roughly equivalent to
871#
872# test_expect_success 'test core.capslock' '
873# git config core.capslock true &&
874# hello world
875# git config --unset core.capslock
876# '
877#
878# except that the greeting and config --unset must both succeed for
879# the test to pass.
880#
881# Note that under --immediate mode, no clean-up is done to help diagnose
882# what went wrong.
883
884test_when_finished () {
0968f12a
JK
885 # We cannot detect when we are in a subshell in general, but by
886 # doing so on Bash is better than nothing (the test will
887 # silently pass on other shells).
888 test "${BASH_SUBSHELL-0}" = 0 ||
889 error "bug in test script: test_when_finished does nothing in a subshell"
12a29b1a
TR
890 test_cleanup="{ $*
891 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
892}
893
894# Most tests can use the created repository, but some may need to create more.
895# Usage: test_create_repo <directory>
896test_create_repo () {
897 test "$#" = 1 ||
898 error "bug in the test script: not 1 parameter to test-create-repo"
899 repo="$1"
900 mkdir -p "$repo"
901 (
902 cd "$repo" || error "Cannot setup test environment"
903 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
904 error "cannot run git init -- have you built things yet?"
905 mv .git/hooks .git/hooks-disabled
906 ) || exit
907}
9ce415d9
JS
908
909# This function helps on symlink challenged file systems when it is not
910# important that the file system entry is a symbolic link.
911# Use test_ln_s_add instead of "ln -s x y && git add y" to add a
912# symbolic link entry y to the index.
913
914test_ln_s_add () {
915 if test_have_prereq SYMLINKS
916 then
917 ln -s "$1" "$2" &&
918 git update-index --add "$2"
919 else
920 printf '%s' "$1" >"$2" &&
921 ln_s_obj=$(git hash-object -w "$2") &&
817d03e1
JS
922 git update-index --add --cacheinfo 120000 $ln_s_obj "$2" &&
923 # pick up stat info from the file
924 git update-index "$2"
9ce415d9
JS
925 fi
926}
4d715ac0 927
ac9afcc3
MT
928# This function writes out its parameters, one per line
929test_write_lines () {
930 printf "%s\n" "$@"
931}
932
a0e0ec9f 933perl () {
a5bf824f
SG
934 command "$PERL_PATH" "$@" 2>&7
935} 7>&2 2>&4
a3a9cff0 936
83d842dc
JK
937# Is the value one of the various ways to spell a boolean true/false?
938test_normalize_bool () {
939 git -c magic.variable="$1" config --bool magic.variable 2>/dev/null
940}
941
942# Given a variable $1, normalize the value of it to one of "true",
943# "false", or "auto" and store the result to it.
944#
945# test_tristate GIT_TEST_HTTPD
946#
947# A variable set to an empty string is set to 'false'.
948# A variable set to 'false' or 'auto' keeps its value.
949# Anything else is set to 'true'.
950# An unset variable defaults to 'auto'.
951#
952# The last rule is to allow people to set the variable to an empty
953# string and export it to decline testing the particular feature
954# for versions both before and after this change. We used to treat
955# both unset and empty variable as a signal for "do not test" and
956# took any non-empty string as "please test".
957
958test_tristate () {
959 if eval "test x\"\${$1+isset}\" = xisset"
960 then
961 # explicitly set
962 eval "
963 case \"\$$1\" in
964 '') $1=false ;;
965 auto) ;;
966 *) $1=\$(test_normalize_bool \$$1 || echo true) ;;
967 esac
968 "
969 else
970 eval "$1=auto"
971 fi
972}
973
974# Exit the test suite, either by skipping all remaining tests or by
975# exiting with an error. If "$1" is "auto", we then we assume we were
976# opportunistically trying to set up some tests and we skip. If it is
977# "true", then we report a failure.
978#
979# The error/skip message should be given by $2.
980#
981test_skip_or_die () {
982 case "$1" in
983 auto)
984 skip_all=$2
985 test_done
986 ;;
987 true)
988 error "$2"
989 ;;
990 *)
991 error "BUG: test tristate is '$1' (real error: $2)"
992 esac
993}
994
4d715ac0
JS
995# The following mingw_* functions obey POSIX shell syntax, but are actually
996# bash scripts, and are meant to be used only with bash on Windows.
997
998# A test_cmp function that treats LF and CRLF equal and avoids to fork
999# diff when possible.
1000mingw_test_cmp () {
1001 # Read text into shell variables and compare them. If the results
1002 # are different, use regular diff to report the difference.
1003 local test_cmp_a= test_cmp_b=
1004
1005 # When text came from stdin (one argument is '-') we must feed it
1006 # to diff.
1007 local stdin_for_diff=
1008
1009 # Since it is difficult to detect the difference between an
1010 # empty input file and a failure to read the files, we go straight
1011 # to diff if one of the inputs is empty.
1012 if test -s "$1" && test -s "$2"
1013 then
1014 # regular case: both files non-empty
1015 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1016 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1017 elif test -s "$1" && test "$2" = -
1018 then
1019 # read 2nd file from stdin
1020 mingw_read_file_strip_cr_ test_cmp_a <"$1"
1021 mingw_read_file_strip_cr_ test_cmp_b
1022 stdin_for_diff='<<<"$test_cmp_b"'
1023 elif test "$1" = - && test -s "$2"
1024 then
1025 # read 1st file from stdin
1026 mingw_read_file_strip_cr_ test_cmp_a
1027 mingw_read_file_strip_cr_ test_cmp_b <"$2"
1028 stdin_for_diff='<<<"$test_cmp_a"'
1029 fi
1030 test -n "$test_cmp_a" &&
1031 test -n "$test_cmp_b" &&
1032 test "$test_cmp_a" = "$test_cmp_b" ||
1033 eval "diff -u \"\$@\" $stdin_for_diff"
1034}
1035
1036# $1 is the name of the shell variable to fill in
1037mingw_read_file_strip_cr_ () {
1038 # Read line-wise using LF as the line separator
1039 # and use IFS to strip CR.
1040 local line
1041 while :
1042 do
1043 if IFS=$'\r' read -r -d $'\n' line
1044 then
1045 # good
1046 line=$line$'\n'
1047 else
1048 # we get here at EOF, but also if the last line
1049 # was not terminated by LF; in the latter case,
1050 # some text was read
1051 if test -z "$line"
1052 then
1053 # EOF, really
1054 break
1055 fi
1056 fi
1057 eval "$1=\$$1\$line"
1058 done
1059}
d2554c72
JK
1060
1061# Like "env FOO=BAR some-program", but run inside a subshell, which means
1062# it also works for shell functions (though those functions cannot impact
1063# the environment outside of the test_env invocation).
1064test_env () {
1065 (
1066 while test $# -gt 0
1067 do
1068 case "$1" in
1069 *=*)
1070 eval "${1%%=*}=\${1#*=}"
1071 eval "export ${1%%=*}"
1072 shift
1073 ;;
1074 *)
a5bf824f 1075 "$@" 2>&7
d2554c72
JK
1076 exit
1077 ;;
1078 esac
1079 done
1080 )
a5bf824f 1081} 7>&2 2>&4
48860819 1082
9b67c994
JK
1083# Returns true if the numeric exit code in "$2" represents the expected signal
1084# in "$1". Signals should be given numerically.
1085test_match_signal () {
1086 if test "$2" = "$((128 + $1))"
1087 then
1088 # POSIX
1089 return 0
1090 elif test "$2" = "$((256 + $1))"
1091 then
1092 # ksh
1093 return 0
1094 fi
1095 return 1
1096}
39cadeec 1097
48860819
JK
1098# Read up to "$1" bytes (or to EOF) from stdin and write them to stdout.
1099test_copy_bytes () {
1100 perl -e '
1101 my $len = $ARGV[1];
1102 while ($len > 0) {
1103 my $s;
1104 my $nread = sysread(STDIN, $s, $len);
1105 die "cannot read: $!" unless defined($nread);
f7f6dc34 1106 last unless $nread;
48860819
JK
1107 print $s;
1108 $len -= $nread;
1109 }
1110 ' - "$1"
1111}
de95302a
JK
1112
1113# run "$@" inside a non-git directory
1114nongit () {
1115 test -d non-repo ||
1116 mkdir non-repo ||
1117 return 1
1118
1119 (
1120 GIT_CEILING_DIRECTORIES=$(pwd) &&
1121 export GIT_CEILING_DIRECTORIES &&
1122 cd non-repo &&
a5bf824f 1123 "$@" 2>&7
de95302a 1124 )
a5bf824f 1125} 7>&2 2>&4
4414a150
JK
1126
1127# convert stdin to pktline representation; note that empty input becomes an
1128# empty packet, not a flush packet (for that you can just print 0000 yourself).
1129packetize() {
1130 cat >packetize.tmp &&
1131 len=$(wc -c <packetize.tmp) &&
1132 printf '%04x%s' "$(($len + 4))" &&
1133 cat packetize.tmp &&
1134 rm -f packetize.tmp
1135}
1136
1137# Parse the input as a series of pktlines, writing the result to stdout.
1138# Sideband markers are removed automatically, and the output is routed to
1139# stderr if appropriate.
1140#
1141# NUL bytes are converted to "\\0" for ease of parsing with text tools.
1142depacketize () {
1143 perl -e '
1144 while (read(STDIN, $len, 4) == 4) {
1145 if ($len eq "0000") {
1146 print "FLUSH\n";
1147 } else {
1148 read(STDIN, $buf, hex($len) - 4);
1149 $buf =~ s/\0/\\0/g;
1150 if ($buf =~ s/^[\x2\x3]//) {
1151 print STDERR $buf;
1152 } else {
1153 $buf =~ s/^\x1//;
1154 print $buf;
1155 }
1156 }
1157 }
1158 '
1159}
2c02b110 1160
1161# Set the hash algorithm in use to $1. Only useful when testing the testsuite.
1162test_set_hash () {
1163 test_hash_algo="$1"
1164}
1165
1166# Detect the hash algorithm in use.
1167test_detect_hash () {
1168 # Currently we only support SHA-1, but in the future this function will
1169 # actually detect the algorithm in use.
1170 test_hash_algo='sha1'
1171}
1172
1173# Load common hash metadata and common placeholder object IDs for use with
1174# test_oid.
1175test_oid_init () {
1176 test -n "$test_hash_algo" || test_detect_hash &&
1177 test_oid_cache <"$TEST_DIRECTORY/oid-info/hash-info" &&
1178 test_oid_cache <"$TEST_DIRECTORY/oid-info/oid"
1179}
1180
1181# Load key-value pairs from stdin suitable for use with test_oid. Blank lines
1182# and lines starting with "#" are ignored. Keys must be shell identifier
1183# characters.
1184#
1185# Examples:
1186# rawsz sha1:20
1187# rawsz sha256:32
1188test_oid_cache () {
1189 local tag rest k v &&
1190
1191 { test -n "$test_hash_algo" || test_detect_hash; } &&
1192 while read tag rest
1193 do
1194 case $tag in
1195 \#*)
1196 continue;;
1197 ?*)
1198 # non-empty
1199 ;;
1200 *)
1201 # blank line
1202 continue;;
1203 esac &&
1204
1205 k="${rest%:*}" &&
1206 v="${rest#*:}" &&
1207
1208 if ! expr "$k" : '[a-z0-9][a-z0-9]*$' >/dev/null
1209 then
1210 error 'bug in the test script: bad hash algorithm'
1211 fi &&
1212 eval "test_oid_${k}_$tag=\"\$v\""
1213 done
1214}
1215
1216# Look up a per-hash value based on a key ($1). The value must have been loaded
1217# by test_oid_init or test_oid_cache.
1218test_oid () {
1219 local var="test_oid_${test_hash_algo}_$1" &&
1220
1221 # If the variable is unset, we must be missing an entry for this
1222 # key-hash pair, so exit with an error.
1223 if eval "test -z \"\${$var+set}\""
1224 then
1225 error "bug in the test script: undefined key '$1'" >&2
1226 fi &&
1227 eval "printf '%s' \"\${$var}\""
1228}